/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
} from "ethers";
import {
  Contract,
  ContractTransaction,
  Overrides,
  PayableOverrides,
  CallOverrides,
} from "@ethersproject/contracts";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";

interface Il1BridgeInterface extends ethers.utils.Interface {
  functions: {
    "claimFailedDeposit(address,address,bytes32,uint256,uint256,uint16,bytes32[])": FunctionFragment;
    "deposit(address,address,uint256,uint256,uint256,address)": FunctionFragment;
    "finalizeWithdrawal(uint256,uint256,uint16,bytes,bytes32[])": FunctionFragment;
    "isWithdrawalFinalized(uint256,uint256)": FunctionFragment;
    "l2Bridge()": FunctionFragment;
    "l2TokenAddress(address)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "claimFailedDeposit",
    values: [
      string,
      string,
      BytesLike,
      BigNumberish,
      BigNumberish,
      BigNumberish,
      BytesLike[]
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "deposit",
    values: [string, string, BigNumberish, BigNumberish, BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "finalizeWithdrawal",
    values: [BigNumberish, BigNumberish, BigNumberish, BytesLike, BytesLike[]]
  ): string;
  encodeFunctionData(
    functionFragment: "isWithdrawalFinalized",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(functionFragment: "l2Bridge", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "l2TokenAddress",
    values: [string]
  ): string;

  decodeFunctionResult(
    functionFragment: "claimFailedDeposit",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "deposit", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "finalizeWithdrawal",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isWithdrawalFinalized",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "l2Bridge", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "l2TokenAddress",
    data: BytesLike
  ): Result;

  events: {
    "ClaimedFailedDeposit(address,address,uint256)": EventFragment;
    "DepositInitiated(bytes32,address,address,address,uint256)": EventFragment;
    "WithdrawalFinalized(address,address,uint256)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "ClaimedFailedDeposit"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "DepositInitiated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "WithdrawalFinalized"): EventFragment;
}

export class Il1Bridge extends Contract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  on(event: EventFilter | string, listener: Listener): this;
  once(event: EventFilter | string, listener: Listener): this;
  addListener(eventName: EventFilter | string, listener: Listener): this;
  removeAllListeners(eventName: EventFilter | string): this;
  removeListener(eventName: any, listener: Listener): this;

  interface: Il1BridgeInterface;

  functions: {
    claimFailedDeposit(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "claimFailedDeposit(address,address,bytes32,uint256,uint256,uint16,bytes32[])"(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    deposit(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: PayableOverrides
    ): Promise<ContractTransaction>;

    "deposit(address,address,uint256,uint256,uint256,address)"(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: PayableOverrides
    ): Promise<ContractTransaction>;

    finalizeWithdrawal(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "finalizeWithdrawal(uint256,uint256,uint16,bytes,bytes32[])"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    isWithdrawalFinalized(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<{
      0: boolean;
    }>;

    "isWithdrawalFinalized(uint256,uint256)"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<{
      0: boolean;
    }>;

    l2Bridge(overrides?: CallOverrides): Promise<{
      0: string;
    }>;

    "l2Bridge()"(overrides?: CallOverrides): Promise<{
      0: string;
    }>;

    l2TokenAddress(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<{
      0: string;
    }>;

    "l2TokenAddress(address)"(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<{
      0: string;
    }>;
  };

  claimFailedDeposit(
    _depositSender: string,
    _l1Token: string,
    _l2TxHash: BytesLike,
    _l2BatchNumber: BigNumberish,
    _l2MessageIndex: BigNumberish,
    _l2TxNumberInBatch: BigNumberish,
    _merkleProof: BytesLike[],
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "claimFailedDeposit(address,address,bytes32,uint256,uint256,uint16,bytes32[])"(
    _depositSender: string,
    _l1Token: string,
    _l2TxHash: BytesLike,
    _l2BatchNumber: BigNumberish,
    _l2MessageIndex: BigNumberish,
    _l2TxNumberInBatch: BigNumberish,
    _merkleProof: BytesLike[],
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  deposit(
    _l2Receiver: string,
    _l1Token: string,
    _amount: BigNumberish,
    _l2TxGasLimit: BigNumberish,
    _l2TxGasPerPubdataByte: BigNumberish,
    _refundRecipient: string,
    overrides?: PayableOverrides
  ): Promise<ContractTransaction>;

  "deposit(address,address,uint256,uint256,uint256,address)"(
    _l2Receiver: string,
    _l1Token: string,
    _amount: BigNumberish,
    _l2TxGasLimit: BigNumberish,
    _l2TxGasPerPubdataByte: BigNumberish,
    _refundRecipient: string,
    overrides?: PayableOverrides
  ): Promise<ContractTransaction>;

  finalizeWithdrawal(
    _l2BatchNumber: BigNumberish,
    _l2MessageIndex: BigNumberish,
    _l2TxNumberInBatch: BigNumberish,
    _message: BytesLike,
    _merkleProof: BytesLike[],
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "finalizeWithdrawal(uint256,uint256,uint16,bytes,bytes32[])"(
    _l2BatchNumber: BigNumberish,
    _l2MessageIndex: BigNumberish,
    _l2TxNumberInBatch: BigNumberish,
    _message: BytesLike,
    _merkleProof: BytesLike[],
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  isWithdrawalFinalized(
    _l2BatchNumber: BigNumberish,
    _l2MessageIndex: BigNumberish,
    overrides?: CallOverrides
  ): Promise<boolean>;

  "isWithdrawalFinalized(uint256,uint256)"(
    _l2BatchNumber: BigNumberish,
    _l2MessageIndex: BigNumberish,
    overrides?: CallOverrides
  ): Promise<boolean>;

  l2Bridge(overrides?: CallOverrides): Promise<string>;

  "l2Bridge()"(overrides?: CallOverrides): Promise<string>;

  l2TokenAddress(_l1Token: string, overrides?: CallOverrides): Promise<string>;

  "l2TokenAddress(address)"(
    _l1Token: string,
    overrides?: CallOverrides
  ): Promise<string>;

  callStatic: {
    claimFailedDeposit(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: CallOverrides
    ): Promise<void>;

    "claimFailedDeposit(address,address,bytes32,uint256,uint256,uint16,bytes32[])"(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: CallOverrides
    ): Promise<void>;

    deposit(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: CallOverrides
    ): Promise<string>;

    "deposit(address,address,uint256,uint256,uint256,address)"(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: CallOverrides
    ): Promise<string>;

    finalizeWithdrawal(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: CallOverrides
    ): Promise<void>;

    "finalizeWithdrawal(uint256,uint256,uint16,bytes,bytes32[])"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: CallOverrides
    ): Promise<void>;

    isWithdrawalFinalized(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<boolean>;

    "isWithdrawalFinalized(uint256,uint256)"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<boolean>;

    l2Bridge(overrides?: CallOverrides): Promise<string>;

    "l2Bridge()"(overrides?: CallOverrides): Promise<string>;

    l2TokenAddress(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<string>;

    "l2TokenAddress(address)"(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<string>;
  };

  filters: {
    ClaimedFailedDeposit(
      to: string | null,
      l1Token: string | null,
      amount: null
    ): EventFilter;

    DepositInitiated(
      l2DepositTxHash: BytesLike | null,
      from: string | null,
      to: string | null,
      l1Token: null,
      amount: null
    ): EventFilter;

    WithdrawalFinalized(
      to: string | null,
      l1Token: string | null,
      amount: null
    ): EventFilter;
  };

  estimateGas: {
    claimFailedDeposit(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<BigNumber>;

    "claimFailedDeposit(address,address,bytes32,uint256,uint256,uint16,bytes32[])"(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<BigNumber>;

    deposit(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: PayableOverrides
    ): Promise<BigNumber>;

    "deposit(address,address,uint256,uint256,uint256,address)"(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: PayableOverrides
    ): Promise<BigNumber>;

    finalizeWithdrawal(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<BigNumber>;

    "finalizeWithdrawal(uint256,uint256,uint16,bytes,bytes32[])"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<BigNumber>;

    isWithdrawalFinalized(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "isWithdrawalFinalized(uint256,uint256)"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    l2Bridge(overrides?: CallOverrides): Promise<BigNumber>;

    "l2Bridge()"(overrides?: CallOverrides): Promise<BigNumber>;

    l2TokenAddress(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "l2TokenAddress(address)"(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    claimFailedDeposit(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "claimFailedDeposit(address,address,bytes32,uint256,uint256,uint16,bytes32[])"(
      _depositSender: string,
      _l1Token: string,
      _l2TxHash: BytesLike,
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    deposit(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: PayableOverrides
    ): Promise<PopulatedTransaction>;

    "deposit(address,address,uint256,uint256,uint256,address)"(
      _l2Receiver: string,
      _l1Token: string,
      _amount: BigNumberish,
      _l2TxGasLimit: BigNumberish,
      _l2TxGasPerPubdataByte: BigNumberish,
      _refundRecipient: string,
      overrides?: PayableOverrides
    ): Promise<PopulatedTransaction>;

    finalizeWithdrawal(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "finalizeWithdrawal(uint256,uint256,uint16,bytes,bytes32[])"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      _l2TxNumberInBatch: BigNumberish,
      _message: BytesLike,
      _merkleProof: BytesLike[],
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    isWithdrawalFinalized(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "isWithdrawalFinalized(uint256,uint256)"(
      _l2BatchNumber: BigNumberish,
      _l2MessageIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    l2Bridge(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    "l2Bridge()"(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    l2TokenAddress(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "l2TokenAddress(address)"(
      _l1Token: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
